# coding:utf-8
"""
ebay api xiangguan ,zhuyao shi listing guanli fangfa
"""
from ebaysdk.trading import Connection as Trading


class EBayAPI:
    """
    ebay listing manage Class

    """
    def __init__(self, account_info, api_type='trading'):
        """
        :param account_info: store info {'AppID':'','certID':'', 'DevID':'', 'Token':''}
        :param api_type: tarding shopping ...
        :return: api of one in trading ,shopping
        """
        if api_type == 'trading':
            try:
                site_id = account_info['SiteID']
            except:
                site_id = ''
            if site_id:
                self.api = Trading(appid=account_info['AppID'], certid=account_info['CertID'],
                                   devid=account_info['DevID'], token=account_info['Token'],
                                   siteid=str(site_id), config_file=None, warnings=False)
            else:
                self.api = Trading(appid=account_info['AppID'], certid=account_info['CertID'],
                                   devid=account_info['DevID'], token=account_info['Token'],
                                   config_file=None, warnings=False)
        else:
            self.api = None

    def __make_call(self, function_name, **params):
        retry_number = 1
        return_info = {'result': False}
        _message = ''
        while True and retry_number < 2:
            retry_number += 1
            try:
                result = self.api.execute(function_name, params).dict()
                return_info['result'] = True
                return_info['data'] = result
                break
            except Exception, e:
                print e
                _message = str(e)
        if not return_info['result']:
            return_info['message'] = _message
        return return_info

    def execute_call(self, function_name, **params):
        """
        do some function by function name
        :param function_name:
        :param params:  the params of this function for you give
        :return: a dict
        """
        return self.__make_call(function_name, **params)
